# Alan Harris, Konstantin Haase - Sinatra: Up and Running

## Highlights and notes

- At a high-level, a domain-specific language is one that is dedicated to solving a particular type of problem. For example, SQL (structured query language) is designed to facilitate interaction with relational database systems. By contrast, a general-purpose language such as Ruby can be used to write code in many different domains.

  highlight @ page 8, loc. 111-113

- Sinatra is not a framework; you’ll find no built-in ORM (object-relational mapper) tools, no pre-fab configuration files...you won’t even get a project folder unless you create one yourself.

  highlight @ page 9, loc. 130-131

- Sinatra does not force you to adhere to the model-view-controller pattern, or any other pattern for that matter. It is a lightweight wrapper around Rack middleware

  highlight @ page 9, loc. 135-136

- Who’s Using It? GitHub, Heroku, BBC, thoughtbot, Songbird, Engine Yard, and many others are active users of Sinatra in production environments.

  highlight @ page 10, loc. 144-146

## Bookmarks

- page 84, loc. 1150
- page 315, loc. 4445
